]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: add a function to run Python tests
[notmuch] / test / test-lib.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color and test_emacs
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*\n"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         rm -rf "$TEST_TMPDIR"
178         if test -n "$GIT_EXIT_OK"
179         then
180                 exit $code
181         else
182                 echo >&5 "FATAL: Unexpected exit with code $code"
183                 exit 1
184         fi
185 }
186
187 GIT_EXIT_OK=
188 # Note: TEST_TMPDIR *NOT* exported!
189 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
190 trap 'die' EXIT
191
192 test_decode_color () {
193         sed     -e 's/.\[1m/<WHITE>/g' \
194                 -e 's/.\[31m/<RED>/g' \
195                 -e 's/.\[32m/<GREEN>/g' \
196                 -e 's/.\[33m/<YELLOW>/g' \
197                 -e 's/.\[34m/<BLUE>/g' \
198                 -e 's/.\[35m/<MAGENTA>/g' \
199                 -e 's/.\[36m/<CYAN>/g' \
200                 -e 's/.\[m/<RESET>/g'
201 }
202
203 q_to_nul () {
204         perl -pe 'y/Q/\000/'
205 }
206
207 q_to_cr () {
208         tr Q '\015'
209 }
210
211 append_cr () {
212         sed -e 's/$/Q/' | tr Q '\015'
213 }
214
215 remove_cr () {
216         tr '\015' Q | sed -e 's/Q$//'
217 }
218
219 # Generate a new message in the mail directory, with a unique message
220 # ID and subject. The message is not added to the index.
221 #
222 # After this function returns, the filename of the generated message
223 # is available as $gen_msg_filename and the message ID is available as
224 # $gen_msg_id .
225 #
226 # This function supports named parameters with the bash syntax for
227 # assigning a value to an associative array ([name]=value). The
228 # supported parameters are:
229 #
230 #  [dir]=directory/of/choice
231 #
232 #       Generate the message in directory 'directory/of/choice' within
233 #       the mail store. The directory will be created if necessary.
234 #
235 #  [filename]=name
236 #
237 #       Store the message in file 'name'. The default is to store it
238 #       in 'msg-<count>', where <count> is three-digit number of the
239 #       message.
240 #       
241 #  [body]=text
242 #
243 #       Text to use as the body of the email message
244 #
245 #  '[from]="Some User <user@example.com>"'
246 #  '[to]="Some User <user@example.com>"'
247 #  '[subject]="Subject of email message"'
248 #  '[date]="RFC 822 Date"'
249 #
250 #       Values for email headers. If not provided, default values will
251 #       be generated instead.
252 #
253 #  '[cc]="Some User <user@example.com>"'
254 #  [reply-to]=some-address
255 #  [in-reply-to]=<message-id>
256 #  [references]=<message-id>
257 #  [content-type]=content-type-specification
258 #  '[header]=full header line, including keyword'
259 #
260 #       Additional values for email headers. If these are not provided
261 #       then the relevant headers will simply not appear in the
262 #       message.
263 #
264 #  '[id]=message-id'
265 #
266 #       Controls the message-id of the created message.
267 gen_msg_cnt=0
268 gen_msg_filename=""
269 gen_msg_id=""
270 generate_message ()
271 {
272     # This is our (bash-specific) magic for doing named parameters
273     local -A template="($@)"
274     local additional_headers
275
276     gen_msg_cnt=$((gen_msg_cnt + 1))
277     if [ -z "${template[filename]}" ]; then
278         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
279     else
280         gen_msg_name=${template[filename]}
281     fi
282
283     if [ -z "${template[id]}" ]; then
284         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
285     else
286         gen_msg_id="${template[id]}"
287     fi
288
289     if [ -z "${template[dir]}" ]; then
290         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
291     else
292         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
293         mkdir -p "$(dirname "$gen_msg_filename")"
294     fi
295
296     if [ -z "${template[body]}" ]; then
297         template[body]="This is just a test message (#${gen_msg_cnt})"
298     fi
299
300     if [ -z "${template[from]}" ]; then
301         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
302     fi
303
304     if [ -z "${template[to]}" ]; then
305         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
306     fi
307
308     if [ -z "${template[subject]}" ]; then
309         template[subject]="Test message #${gen_msg_cnt}"
310     fi
311
312     if [ -z "${template[date]}" ]; then
313         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
314     fi
315
316     additional_headers=""
317     if [ ! -z "${template[header]}" ]; then
318         additional_headers="${template[header]}
319 ${additional_headers}"
320     fi
321
322     if [ ! -z "${template[reply-to]}" ]; then
323         additional_headers="Reply-To: ${template[reply-to]}
324 ${additional_headers}"
325     fi
326
327     if [ ! -z "${template[in-reply-to]}" ]; then
328         additional_headers="In-Reply-To: ${template[in-reply-to]}
329 ${additional_headers}"
330     fi
331
332     if [ ! -z "${template[cc]}" ]; then
333         additional_headers="Cc: ${template[cc]}
334 ${additional_headers}"
335     fi
336
337     if [ ! -z "${template[references]}" ]; then
338         additional_headers="References: ${template[references]}
339 ${additional_headers}"
340     fi
341
342     if [ ! -z "${template[content-type]}" ]; then
343         additional_headers="Content-Type: ${template[content-type]}
344 ${additional_headers}"
345     fi
346
347     # Note that in the way we're setting it above and using it below,
348     # `additional_headers' will also serve as the header / body separator
349     # (empty line in between).
350
351     cat <<EOF >"$gen_msg_filename"
352 From: ${template[from]}
353 To: ${template[to]}
354 Message-Id: <${gen_msg_id}>
355 Subject: ${template[subject]}
356 Date: ${template[date]}
357 ${additional_headers}
358 ${template[body]}
359 EOF
360 }
361
362 # Generate a new message and add it to the database.
363 #
364 # All of the arguments and return values supported by generate_message
365 # are also supported here, so see that function for details.
366 add_message ()
367 {
368     generate_message "$@" &&
369     notmuch new > /dev/null
370 }
371
372 # Deliver a message with emacs and add it to the database
373 #
374 # Uses emacs to generate and deliver a message to the mail store.
375 # Accepts arbitrary extra emacs/elisp functions to modify the message
376 # before sending, which is useful to doing things like attaching files
377 # to the message and encrypting/signing.
378 emacs_deliver_message ()
379 {
380     local subject="$1"
381     local body="$2"
382     shift 2
383     # before we can send a message, we have to prepare the FCC maildir
384     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
385     $TEST_DIRECTORY/smtp-dummy sent_message &
386     smtp_dummy_pid=$!
387     test_emacs \
388         "(let ((message-send-mail-function 'message-smtpmail-send-it)
389                (smtpmail-smtp-server \"localhost\")
390                (smtpmail-smtp-service \"25025\"))
391            (notmuch-hello)
392            (notmuch-mua-mail)
393            (message-goto-to)
394            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
395            (message-goto-subject)
396            (insert \"${subject}\")
397            (message-goto-body)
398            (insert \"${body}\")
399            $@
400            (message-send-and-exit))"
401     # opportunistically quit smtp-dummy in case above fails.
402     { echo QUIT > /dev/tcp/localhost/25025; } 2>/dev/null
403     wait ${smtp_dummy_pid}
404     notmuch new >/dev/null
405 }
406
407 # Generate a corpus of email and add it to the database.
408 #
409 # This corpus is fixed, (it happens to be 50 messages from early in
410 # the history of the notmuch mailing list), which allows for reliably
411 # testing commands that need to operate on a not-totally-trivial
412 # number of messages.
413 add_email_corpus ()
414 {
415     rm -rf ${MAIL_DIR}
416     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
417         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
418     else
419         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
420         notmuch new >/dev/null
421         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
422     fi
423 }
424
425 test_begin_subtest ()
426 {
427     if [ -n "$inside_subtest" ]; then
428         exec 1>&6 2>&7          # Restore stdout and stderr
429         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
430     fi
431     test_subtest_name="$1"
432     test_reset_state_
433     # Remember stdout and stderr file descriptors and redirect test
434     # output to the previously prepared file descriptors 3 and 4 (see
435     # below)
436     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
437     exec 6>&1 7>&2 >&3 2>&4
438     inside_subtest=t
439 }
440
441 # Pass test if two arguments match
442 #
443 # Note: Unlike all other test_expect_* functions, this function does
444 # not accept a test name. Instead, the caller should call
445 # test_begin_subtest before calling this function in order to set the
446 # name.
447 test_expect_equal ()
448 {
449         exec 1>&6 2>&7          # Restore stdout and stderr
450         inside_subtest=
451         test "$#" = 3 && { prereq=$1; shift; } || prereq=
452         test "$#" = 2 ||
453         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
454
455         output="$1"
456         expected="$2"
457         if ! test_skip "$test_subtest_name"
458         then
459                 if [ "$output" = "$expected" ]; then
460                         test_ok_ "$test_subtest_name"
461                 else
462                         testname=$this_test.$test_count
463                         echo "$expected" > $testname.expected
464                         echo "$output" > $testname.output
465                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
466                 fi
467     fi
468 }
469
470 # Like test_expect_equal, but takes two filenames.
471 test_expect_equal_file ()
472 {
473         exec 1>&6 2>&7          # Restore stdout and stderr
474         inside_subtest=
475         test "$#" = 3 && { prereq=$1; shift; } || prereq=
476         test "$#" = 2 ||
477         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
478
479         output="$1"
480         expected="$2"
481         if ! test_skip "$test_subtest_name"
482         then
483                 if diff -q "$expected" "$output" >/dev/null ; then
484                         test_ok_ "$test_subtest_name"
485                 else
486                         testname=$this_test.$test_count
487                         cp "$output" $testname.output
488                         cp "$expected" $testname.expected
489                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
490                 fi
491     fi
492 }
493
494 NOTMUCH_NEW ()
495 {
496     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
497 }
498
499 notmuch_search_sanitize ()
500 {
501     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
502 }
503
504 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
505 notmuch_show_sanitize ()
506 {
507     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
508 }
509 notmuch_show_sanitize_all ()
510 {
511     sed \
512         -e 's| filename:.*| filename:XXXXX|' \
513         -e 's| id:[^ ]* | id:XXXXX |'
514 }
515
516 notmuch_json_show_sanitize ()
517 {
518     sed -e 's|, |,\n |g' | \
519         sed \
520         -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
521         -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
522 }
523
524 # End of notmuch helper functions
525
526 # Use test_set_prereq to tell that a particular prerequisite is available.
527 # The prerequisite can later be checked for in two ways:
528 #
529 # - Explicitly using test_have_prereq.
530 #
531 # - Implicitly by specifying the prerequisite tag in the calls to
532 #   test_expect_{success,failure,code}.
533 #
534 # The single parameter is the prerequisite tag (a simple word, in all
535 # capital letters by convention).
536
537 test_set_prereq () {
538         satisfied="$satisfied$1 "
539 }
540 satisfied=" "
541
542 test_have_prereq () {
543         case $satisfied in
544         *" $1 "*)
545                 : yes, have it ;;
546         *)
547                 ! : nope ;;
548         esac
549 }
550
551 # declare prerequisite for the given external binary
552 test_declare_external_prereq () {
553         binary="$1"
554         test "$#" = 2 && name=$2 || name="$binary(1)"
555
556         hash $binary 2>/dev/null || eval "
557         test_missing_external_prereq_${binary}_=t
558 $binary () {
559         echo -n \"\$test_subtest_missing_external_prereqs_ \" | grep -qe \" $name \" ||
560         test_subtest_missing_external_prereqs_=\"\$test_subtest_missing_external_prereqs_ $name\"
561         false
562 }"
563 }
564
565 # Explicitly require external prerequisite.  Useful when binary is
566 # called indirectly (e.g. from emacs).
567 # Returns success if dependency is available, failure otherwise.
568 test_require_external_prereq () {
569         binary="$1"
570         if [ "$(eval echo -n \$test_missing_external_prereq_${binary}_)" = t ]; then
571                 # dependency is missing, call the replacement function to note it
572                 eval "$binary"
573         else
574                 true
575         fi
576 }
577
578 # You are not expected to call test_ok_ and test_failure_ directly, use
579 # the text_expect_* functions instead.
580
581 test_ok_ () {
582         if test "$test_subtest_known_broken_" = "t"; then
583                 test_known_broken_ok_ "$@"
584                 return
585         fi
586         test_success=$(($test_success + 1))
587         say_color pass "%-6s" "PASS"
588         echo " $@"
589 }
590
591 test_failure_ () {
592         if test "$test_subtest_known_broken_" = "t"; then
593                 test_known_broken_failure_ "$@"
594                 return
595         fi
596         test_failure=$(($test_failure + 1))
597         test_failure_message_ "FAIL" "$@"
598         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
599         return 1
600 }
601
602 test_failure_message_ () {
603         say_color error "%-6s" "$1"
604         echo " $2"
605         shift 2
606         echo "$@" | sed -e 's/^/        /'
607         if test "$verbose" != "t"; then cat test.output; fi
608 }
609
610 test_known_broken_ok_ () {
611         test_reset_state_
612         test_fixed=$(($test_fixed+1))
613         say_color pass "%-6s" "FIXED"
614         echo " $@"
615 }
616
617 test_known_broken_failure_ () {
618         test_reset_state_
619         test_broken=$(($test_broken+1))
620         test_failure_message_ "BROKEN" "$@"
621         return 1
622 }
623
624 test_debug () {
625         test "$debug" = "" || eval "$1"
626 }
627
628 test_run_ () {
629         test_cleanup=:
630         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
631         eval >&3 2>&4 "$1"
632         eval_ret=$?
633         eval >&3 2>&4 "$test_cleanup"
634         return 0
635 }
636
637 test_skip () {
638         test_count=$(($test_count+1))
639         to_skip=
640         for skp in $NOTMUCH_SKIP_TESTS
641         do
642                 case $this_test.$test_count in
643                 $skp)
644                         to_skip=t
645                 esac
646         done
647         if test -z "$to_skip" && test -n "$prereq" &&
648            ! test_have_prereq "$prereq"
649         then
650                 to_skip=t
651         fi
652         case "$to_skip" in
653         t)
654                 test_report_skip_ "$@"
655                 ;;
656         *)
657                 test_check_missing_external_prereqs_ "$@"
658                 ;;
659         esac
660 }
661
662 test_check_missing_external_prereqs_ () {
663         if test -n "$test_subtest_missing_external_prereqs_"; then
664                 say_color skip >&3 "missing prerequisites:"
665                 echo "$test_subtest_missing_external_prereqs_" >&3
666                 test_report_skip_ "$@"
667         else
668                 false
669         fi
670 }
671
672 test_report_skip_ () {
673         test_reset_state_
674         say_color skip >&3 "skipping test:"
675         echo " $@" >&3
676         say_color skip "%-6s" "SKIP"
677         echo " $1"
678 }
679
680 test_subtest_known_broken () {
681         test_subtest_known_broken_=t
682 }
683
684 test_expect_success () {
685         test "$#" = 3 && { prereq=$1; shift; } || prereq=
686         test "$#" = 2 ||
687         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
688         test_reset_state_
689         if ! test_skip "$@"
690         then
691                 test_run_ "$2"
692                 run_ret="$?"
693                 # test_run_ may update missing external prerequisites
694                 test_check_missing_external_prereqs_ "$@" ||
695                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
696                 then
697                         test_ok_ "$1"
698                 else
699                         test_failure_ "$@"
700                 fi
701         fi
702 }
703
704 test_expect_code () {
705         test "$#" = 4 && { prereq=$1; shift; } || prereq=
706         test "$#" = 3 ||
707         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
708         test_reset_state_
709         if ! test_skip "$@"
710         then
711                 test_run_ "$3"
712                 run_ret="$?"
713                 # test_run_ may update missing external prerequisites,
714                 test_check_missing_external_prereqs_ "$@" ||
715                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
716                 then
717                         test_ok_ "$2"
718                 else
719                         test_failure_ "$@"
720                 fi
721         fi
722 }
723
724 # test_external runs external test scripts that provide continuous
725 # test output about their progress, and succeeds/fails on
726 # zero/non-zero exit code.  It outputs the test output on stdout even
727 # in non-verbose mode, and announces the external script with "* run
728 # <n>: ..." before running it.  When providing relative paths, keep in
729 # mind that all scripts run in "trash directory".
730 # Usage: test_external description command arguments...
731 # Example: test_external 'Perl API' perl ../path/to/test.pl
732 test_external () {
733         test "$#" = 4 && { prereq=$1; shift; } || prereq=
734         test "$#" = 3 ||
735         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
736         descr="$1"
737         shift
738         test_reset_state_
739         if ! test_skip "$descr" "$@"
740         then
741                 # Announce the script to reduce confusion about the
742                 # test output that follows.
743                 say_color "" " run $test_count: $descr ($*)"
744                 # Run command; redirect its stderr to &4 as in
745                 # test_run_, but keep its stdout on our stdout even in
746                 # non-verbose mode.
747                 "$@" 2>&4
748                 if [ "$?" = 0 ]
749                 then
750                         test_ok_ "$descr"
751                 else
752                         test_failure_ "$descr" "$@"
753                 fi
754         fi
755 }
756
757 # Like test_external, but in addition tests that the command generated
758 # no output on stderr.
759 test_external_without_stderr () {
760         # The temporary file has no (and must have no) security
761         # implications.
762         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
763         stderr="$tmp/git-external-stderr.$$.tmp"
764         test_external "$@" 4> "$stderr"
765         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
766         descr="no stderr: $1"
767         shift
768         if [ ! -s "$stderr" ]; then
769                 rm "$stderr"
770                 test_ok_ "$descr"
771         else
772                 if [ "$verbose" = t ]; then
773                         output=`echo; echo Stderr is:; cat "$stderr"`
774                 else
775                         output=
776                 fi
777                 # rm first in case test_failure exits.
778                 rm "$stderr"
779                 test_failure_ "$descr" "$@" "$output"
780         fi
781 }
782
783 # This is not among top-level (test_expect_success)
784 # but is a prefix that can be used in the test script, like:
785 #
786 #       test_expect_success 'complain and die' '
787 #           do something &&
788 #           do something else &&
789 #           test_must_fail git checkout ../outerspace
790 #       '
791 #
792 # Writing this as "! git checkout ../outerspace" is wrong, because
793 # the failure could be due to a segv.  We want a controlled failure.
794
795 test_must_fail () {
796         "$@"
797         test $? -gt 0 -a $? -le 129 -o $? -gt 192
798 }
799
800 # test_cmp is a helper function to compare actual and expected output.
801 # You can use it like:
802 #
803 #       test_expect_success 'foo works' '
804 #               echo expected >expected &&
805 #               foo >actual &&
806 #               test_cmp expected actual
807 #       '
808 #
809 # This could be written as either "cmp" or "diff -u", but:
810 # - cmp's output is not nearly as easy to read as diff -u
811 # - not all diff versions understand "-u"
812
813 test_cmp() {
814         $GIT_TEST_CMP "$@"
815 }
816
817 # This function can be used to schedule some commands to be run
818 # unconditionally at the end of the test to restore sanity:
819 #
820 #       test_expect_success 'test core.capslock' '
821 #               git config core.capslock true &&
822 #               test_when_finished "git config --unset core.capslock" &&
823 #               hello world
824 #       '
825 #
826 # That would be roughly equivalent to
827 #
828 #       test_expect_success 'test core.capslock' '
829 #               git config core.capslock true &&
830 #               hello world
831 #               git config --unset core.capslock
832 #       '
833 #
834 # except that the greeting and config --unset must both succeed for
835 # the test to pass.
836
837 test_when_finished () {
838         test_cleanup="{ $*
839                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
840 }
841
842 test_done () {
843         GIT_EXIT_OK=t
844         test_results_dir="$TEST_DIRECTORY/test-results"
845         mkdir -p "$test_results_dir"
846         test_results_path="$test_results_dir/${0%.sh}-$$"
847
848         echo "total $test_count" >> $test_results_path
849         echo "success $test_success" >> $test_results_path
850         echo "fixed $test_fixed" >> $test_results_path
851         echo "broken $test_broken" >> $test_results_path
852         echo "failed $test_failure" >> $test_results_path
853         echo "" >> $test_results_path
854
855         echo
856
857         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
858
859         if [ "$test_failure" = "0" ]; then
860             if [ "$test_broken" = "0" ]; then       
861                 rm -rf "$remove_tmp"
862             fi
863             exit 0
864         else
865             exit 1
866         fi
867 }
868
869 emacs_generate_script () {
870         # Construct a little test script here for the benefit of the user,
871         # (who can easily run "run_emacs" to get the same emacs environment
872         # for investigating any failures).    
873         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
874 #!/bin/sh
875 export PATH=$PATH
876 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
877
878 # Here's what we are using here:
879 #
880 # --no-init-file        Don't load users ~/.emacs
881 #
882 # --no-site-file        Don't load the site-wide startup stuff
883 #
884 # --directory           Ensure that the local elisp sources are found
885 #
886 # --load                Force loading of notmuch.el and test-lib.el
887
888 exec emacs --no-init-file --no-site-file \
889         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
890         --directory "$TEST_DIRECTORY" --load test-lib.el \
891         "\$@"
892 EOF
893         chmod a+x "$TMP_DIRECTORY/run_emacs"
894 }
895
896 test_emacs () {
897         # test dependencies beforehand to avoid the waiting loop below
898         test_require_external_prereq emacs || return
899         test_require_external_prereq emacsclient || return
900
901         if [ -z "$EMACS_SERVER" ]; then
902                 server_name="notmuch-test-suite-$$"
903                 # start a detached session with an emacs server
904                 # user's TERM is given to dtach which assumes a minimally
905                 # VT100-compatible terminal -- and emacs inherits that
906                 TERM=$ORIGINAL_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
907                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
908                                 --no-window-system \
909                                 --eval '(setq server-name \"$server_name\")' \
910                                 --eval '(server-start)' \
911                                 --eval '(orphan-watchdog $$)'" || return
912                 EMACS_SERVER="$server_name"
913                 # wait until the emacs server is up
914                 until test_emacs '()' 2>/dev/null; do
915                         sleep 1
916                 done
917         fi
918
919         emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
920 }
921
922 test_python() {
923         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
924         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
925
926         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
927                 | python -
928 }
929
930 # Creates a script that counts how much time it is executed and calls
931 # notmuch.  $notmuch_counter_command is set to the path to the
932 # generated script.  Use notmuch_counter_value() function to get the
933 # current counter value.
934 notmuch_counter_reset () {
935         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
936         if [ ! -x "$notmuch_counter_command" ]; then
937                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
938                 cat >"$notmuch_counter_command" <<EOF || return
939 #!/bin/sh
940
941 read count < "$notmuch_counter_state_path"
942 echo \$((count + 1)) > "$notmuch_counter_state_path"
943
944 exec notmuch "\$@"
945 EOF
946                 chmod +x "$notmuch_counter_command" || return
947         fi
948
949         echo 0 > "$notmuch_counter_state_path"
950 }
951
952 # Returns the current notmuch counter value.
953 notmuch_counter_value () {
954         if [ -r "$notmuch_counter_state_path" ]; then
955                 read count < "$notmuch_counter_state_path"
956         else
957                 count=0
958         fi
959         echo $count
960 }
961
962 test_reset_state_ () {
963         test -z "$test_init_done_" && test_init_
964
965         test_subtest_known_broken_=
966         test_subtest_missing_external_prereqs_=
967 }
968
969 # called once before the first subtest
970 test_init_ () {
971         test_init_done_=t
972
973         # skip all tests if there were external prerequisites missing during init
974         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
975 }
976
977
978 find_notmuch_path ()
979 {
980     dir="$1"
981
982     while [ -n "$dir" ]; do
983         bin="$dir/notmuch"
984         if [ -x "$bin" ]; then
985             echo "$dir"
986             return
987         fi
988         dir="$(dirname "$dir")"
989         if [ "$dir" = "/" ]; then
990             break
991         fi
992     done
993 }
994
995 # Test the binaries we have just built.  The tests are kept in
996 # test/ subdirectory and are run in 'trash directory' subdirectory.
997 TEST_DIRECTORY=$(pwd)
998 if test -n "$valgrind"
999 then
1000         make_symlink () {
1001                 test -h "$2" &&
1002                 test "$1" = "$(readlink "$2")" || {
1003                         # be super paranoid
1004                         if mkdir "$2".lock
1005                         then
1006                                 rm -f "$2" &&
1007                                 ln -s "$1" "$2" &&
1008                                 rm -r "$2".lock
1009                         else
1010                                 while test -d "$2".lock
1011                                 do
1012                                         say "Waiting for lock on $2."
1013                                         sleep 1
1014                                 done
1015                         fi
1016                 }
1017         }
1018
1019         make_valgrind_symlink () {
1020                 # handle only executables
1021                 test -x "$1" || return
1022
1023                 base=$(basename "$1")
1024                 symlink_target=$TEST_DIRECTORY/../$base
1025                 # do not override scripts
1026                 if test -x "$symlink_target" &&
1027                     test ! -d "$symlink_target" &&
1028                     test "#!" != "$(head -c 2 < "$symlink_target")"
1029                 then
1030                         symlink_target=$TEST_DIRECTORY/valgrind.sh
1031                 fi
1032                 case "$base" in
1033                 *.sh|*.perl)
1034                         symlink_target=$TEST_DIRECTORY/unprocessed-script
1035                 esac
1036                 # create the link, or replace it if it is out of date
1037                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1038         }
1039
1040         # override notmuch executable in TEST_DIRECTORY/..
1041         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1042         mkdir -p "$GIT_VALGRIND"/bin
1043         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
1044         OLDIFS=$IFS
1045         IFS=:
1046         for path in $PATH
1047         do
1048                 ls "$path"/notmuch 2> /dev/null |
1049                 while read file
1050                 do
1051                         make_valgrind_symlink "$file"
1052                 done
1053         done
1054         IFS=$OLDIFS
1055         PATH=$GIT_VALGRIND/bin:$PATH
1056         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1057         export GIT_VALGRIND
1058 else # normal case
1059         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
1060         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
1061 fi
1062 export PATH
1063
1064 # Test repository
1065 test="tmp.$(basename "$0" .sh)"
1066 test -n "$root" && test="$root/$test"
1067 case "$test" in
1068 /*) TMP_DIRECTORY="$test" ;;
1069  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1070 esac
1071 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
1072 rm -fr "$test" || {
1073         GIT_EXIT_OK=t
1074         echo >&5 "FATAL: Cannot prepare test area"
1075         exit 1
1076 }
1077
1078 # A temporary home directory is needed by at least:
1079 # - emacs/"Sending a message via (fake) SMTP"
1080 # - emacs/"Reply within emacs"
1081 # - crypto/emacs_deliver_message
1082 export HOME="${TMP_DIRECTORY}/home"
1083 mkdir -p "${HOME}"
1084
1085 MAIL_DIR="${TMP_DIRECTORY}/mail"
1086 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
1087 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
1088
1089 mkdir -p "${test}"
1090 mkdir -p "${MAIL_DIR}"
1091
1092 cat <<EOF >"${NOTMUCH_CONFIG}"
1093 [database]
1094 path=${MAIL_DIR}
1095
1096 [user]
1097 name=Notmuch Test Suite
1098 primary_email=test_suite@notmuchmail.org
1099 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
1100 EOF
1101
1102 emacs_generate_script
1103
1104
1105 # Use -P to resolve symlinks in our working directory so that the cwd
1106 # in subprocesses like git equals our $PWD (for pathname comparisons).
1107 cd -P "$test" || error "Cannot setup test environment"
1108
1109 if test "$verbose" = "t"
1110 then
1111         exec 4>&2 3>&1
1112 else
1113         exec 4>test.output 3>&4
1114 fi
1115
1116 this_test=${0##*/}
1117 for skp in $NOTMUCH_SKIP_TESTS
1118 do
1119         to_skip=
1120         for skp in $NOTMUCH_SKIP_TESTS
1121         do
1122                 case "$this_test" in
1123                 $skp)
1124                         to_skip=t
1125                 esac
1126         done
1127         case "$to_skip" in
1128         t)
1129                 say_color skip >&3 "skipping test $this_test altogether"
1130                 say_color skip "skip all tests in $this_test"
1131                 test_done
1132         esac
1133 done
1134
1135 # Provide an implementation of the 'yes' utility
1136 yes () {
1137         if test $# = 0
1138         then
1139                 y=y
1140         else
1141                 y="$*"
1142         fi
1143
1144         while echo "$y"
1145         do
1146                 :
1147         done
1148 }
1149
1150 # Fix some commands on Windows
1151 case $(uname -s) in
1152 *MINGW*)
1153         # Windows has its own (incompatible) sort and find
1154         sort () {
1155                 /usr/bin/sort "$@"
1156         }
1157         find () {
1158                 /usr/bin/find "$@"
1159         }
1160         sum () {
1161                 md5sum "$@"
1162         }
1163         # git sees Windows-style pwd
1164         pwd () {
1165                 builtin pwd -W
1166         }
1167         # no POSIX permissions
1168         # backslashes in pathspec are converted to '/'
1169         # exec does not inherit the PID
1170         ;;
1171 *)
1172         test_set_prereq POSIXPERM
1173         test_set_prereq BSLASHPSPEC
1174         test_set_prereq EXECKEEPSPID
1175         ;;
1176 esac
1177
1178 test -z "$NO_PERL" && test_set_prereq PERL
1179 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1180
1181 # test whether the filesystem supports symbolic links
1182 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1183 rm -f y
1184
1185 # declare prerequisites for external binaries used in tests
1186 test_declare_external_prereq dtach
1187 test_declare_external_prereq emacs
1188 test_declare_external_prereq emacsclient
1189 test_declare_external_prereq gdb
1190 test_declare_external_prereq gpg
1191 test_declare_external_prereq python